daftar_pasien/urls.py
from django.urls import path

from . import views

app_name = 'daftar_pasien'

urlpatterns = [
    path('', views.index, name='index'),
    path('daftar/', views.daftar, name='daftar'),
    path('list-pasien/', views.list_pasien, name='list_pasien'),
    path("detail-pasien/<int:nik>", views.detail_pasien, name='detail_pasien'),
    path("delete-pasien/<int:nik>", views.delete_pasien, name='delete_pasien'),
    path("update-pasien/<int:nik>", views.update_pasien, name='update_pasien')
]

e6_siruco/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('', include('hanif.urls')),
    path('authentication/', include('authentication.urls')),
    path('transaksi-makan/', include('transaksi_makan.urls')),
    path('paket-makan/', include('paket_makan.urls')),
    path('hotel/', include('hotel.urls')),
    path('jadwal-dokter/', include('jadwal_dokter.urls')),
    path('daftar-pasien/', include('daftar_pasien.urls')),
    path('appointment/', include('appointment.urls')),
    path('faskes/', include('faskes.urls')),
    path('jadwal_faskes/', include('jadwal_faskes.urls')),
    path('rumahsakit/', include('rumahsakit.urls')),
    path('reservasiRS/', include('reservasiRS.urls')),
    path('transaksirs/', include('transaksirs.urls')),
    path('ruangan-rs/', include('ruangan_rs.urls')),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
]

daftar_pasien/models.py
from django.db import models

# Create your models here.

daftar_pasien/views.py
from django.shortcuts import render, redirect
from django.db import connection
from django.db.utils import IntegrityError, InternalError
from django.contrib import messages
import traceback

# Create your views here.
def index(request):
    return render(request, 'daftar_pasien/index.html')

def daftar(request):
    with connection.cursor() as cursor:
        try:
            cursor.execute(f"""
                SELECT * FROM PASIEN
                WHERE nik = '{request.POST['nik']}'
            """)

            if (len(cursor.fetchall()) == 0):
                cursor.execute(f"""
                    INSERT INTO PASIEN VALUES
                    ('{request.POST['nik']}', '{request.session.get("username")}', '{request.POST['nama']}', 
                    '{request.POST['ktp_jalan']}', '{request.POST['ktp_kelurahan']}', '{request.POST['ktp_kecamatan']}', 
                    '{request.POST['ktp_kabkot']}', '{request.POST['ktp_prov']}', '{request.POST['dom_jalan']}', 
                    '{request.POST['dom_kelurahan']}', '{request.POST['dom_kecamatan']}', '{request.POST['dom_kabkot']}', 
                    '{request.POST['dom_prov']}', '{request.POST['notelp']}', '{request.POST['nohp']}')
                """)
            else:
                messages.add_message(request, messages.WARNING, f"Pasien dengan NIK {request.POST['nik']} sudah terdaftar di sistem!")
                return redirect("daftar_pasien:index")
        except:
            traceback.print_exc()
            messages.add_message(request, messages.WARNING, f"Ada gangguan server internal, mohon coba lagi")
            return redirect("daftar_pasien:index")

    return redirect("daftar_pasien:list_pasien")

def list_pasien(request):
    with connection.cursor() as cursor:
        try:
            cursor.execute(f"""
                SELECT * FROM PASIEN
                WHERE idpendaftar = '{request.session.get("username")}'
            """)

            pasien = cursor.fetchall()

            return render(request, 'daftar_pasien/list_pasien.html', {'pasien':pasien})
        except:
            traceback.print_exc()
            messages.add_message(request, messages.WARNING, f"Ada gangguan server internal, mohon coba lagi")

def detail_pasien(request, nik):
    with connection.cursor() as cursor:
        try:
            cursor.execute(f"""
                SELECT * FROM PASIEN
                WHERE idpendaftar='{request.session.get("username")}'
                AND nik='{nik}'
            """)

            pasien = cursor.fetchall()

            if len(pasien) == 0:
                messages.add_message(request, messages.WARNING, f"Pasien dengan NIK {nik} tidak ditermukan!")

            return render(request, 'daftar_pasien/detail_pasien.html', {'pasien':pasien})
        except:
            print("except")
            traceback.print_exc()
            messages.add_message(request, messages.WARNING, f"Ada gangguan server internal, mohon coba lagi")
            return render(request, 'daftar_pasien/detail_pasien.html')

def delete_pasien(request, nik):
    if request.session.get('peran') != 'pengguna publik':
        return redirect('main:home')
    else:
        with connection.cursor() as cursor:
            try:
                cursor.execute(f"""
                    SELECT idpendaftar FROM PASIEN
                    WHERE idpendaftar='{request.session.get("username")}'
                    AND nik='{nik}'
                """)
                pendaftar = cursor.fetchall()[0][0]
                cursor.execute(f"""
                    DELETE FROM PASIEN
                    WHERE idpendaftar='{request.session.get("username")}'
                    AND nik='{nik}'
                """)
                
                if len(pendaftar) != 0:
                    cursor.execute(f"""
                        DELETE FROM GEJALA_PASIEN
                        WHERE nik='{nik}'
                    """)
                    
                    cursor.execute(f"""
                        DELETE FROM MEMERIKSA
                        WHERE nik='{nik}'
                    """)

                return redirect("daftar_pasien:list_pasien")
            except:
                traceback.print_exc()
                return redirect("daftar_pasien:list_pasien")

def update_pasien(request, nik):
    if request.method == "POST":
        with connection.cursor() as cursor:
            try:
                cursor.execute(f"""
                    SELECT * FROM PASIEN
                    WHERE idpendaftar='{request.session.get("username")}'
                    AND nik='{nik}'
                """)

                if len(cursor.fetchall()) != 0:
                    cursor.execute(f"""
                        UPDATE PASIEN
                        SET ktp_jalan='{request.POST['ktp_jalan']}', ktp_kelurahan='{request.POST['ktp_kelurahan']}', 
                        ktp_kecamatan='{request.POST['ktp_kecamatan']}', ktp_kabkot='{request.POST['ktp_kabkot']}', 
                        ktp_prov='{request.POST['ktp_prov']}', dom_jalan='{request.POST['dom_jalan']}', 
                        dom_kelurahan='{request.POST['dom_kelurahan']}', dom_kecamatan='{request.POST['dom_kecamatan']}', 
                        dom_kabkot='{request.POST['dom_kabkot']}', dom_prov='{request.POST['dom_prov']}', 
                        notelp='{request.POST['notelp']}', nohp='{request.POST['nohp']}'
                        WHERE nik='{nik}' AND idpendaftar='{request.session.get("username")}'
                    """)
                    return redirect("daftar_pasien:list_pasien")
            
            except:
                traceback.print_exc()
                return redirect("daftar_pasien:list_pasien")
    
    with connection.cursor() as cursor:
        cursor.execute(f"""
                    SELECT * FROM PASIEN
                    WHERE idpendaftar='{request.session.get("username")}'
                    AND nik='{nik}'
                """)
        pasien = cursor.fetchall()

    return render(request, "daftar_pasien/update.html", {'pasien':pasien})
            

daftar_pasien/templates/daftar_pasien/detail_pasien.html
{% extends 'base.html' %}

{% block content %}
{% if request.session.peran == 'pengguna publik' %}
<div class="container">
    <h1>Detail Pasien</h1>
    {% for detail in pasien %}
    <div>Pendaftar: {{ detail.1 }}</div>
    <div>NIK: {{ detail.0 }}</div>
    <div>Nama: {{ detail.2 }}</div>
    <div>Nomor Telepon: {{ detail.13 }}</div>
    <div>Nomor HP: {{ detail.14 }}</div>

    <br>
    <h5>Alamat sesuai KTP</h5>
    <div>Jalan: {{ detail.3 }}</div>
    <div>Kelurahan: {{ detail.4 }}</div>
    <div>Kecamatan: {{ detail.5 }}</div>
    <div>Kabupaten/Kota: {{ detail.6 }}</div>
    <div>Provinsi: {{ detail.7 }}</div>

    <br>
    <h5>Alamat Domisili</h5>
    <div>Jalan: {{ detail.8 }}</div>
    <div>Kelurahan: {{ detail.9 }}</div>
    <div>Kecamatan: {{ detail.10 }}</div>
    <div>Kabupaten/Kota: {{ detail.11 }}</div>
    <div>Provinsi: {{ detail.12 }}</div>
    {% endfor %}
    {% for message in messages %}
    {{ message }}
    {% endfor %}
    <a href={% url 'daftar_pasien:list_pasien' %} class="btn btn-outline-danger">Kembali</a>
</div>
{% else %}
<figure class="text-center">
    <h1>Anda tidak punya akses untuk halaman ini</h1>
</figure>
{% endif %}
{% endblock content %}

daftar_pasien/templates/daftar_pasien/index.html
{% extends 'base.html' %}
{% load static %}

{% block content %}
{% if request.session.peran == 'pengguna publik' %}
<div class="container">
    <div class="row"></div>
    <div class="row align-items-center">
        <div class="col"></div>
            <div class="col-6">
                <form method="POST" class="was-validated" action="{% url 'daftar_pasien:daftar' %}">
                    {% csrf_token %}
                    <figure class="text-center">
                        <h3>Siruco - Daftar Pasien</h3>
                    </figure>
                    <div class="mb-3">
                        <label for="usernameInput" class="form-label">Pendaftar</label>
                        <input type="text" class="form-control disabled" name="idpendaftar" id="usernameInput" value="{{ request.session.username }}" readonly>
                    </div>

                    <div class="mb-3 has-validation">
                        <label for="nikInput" class"form-label">NIK</label>
                        <input type="tel" pattern="[0-9]{16}" maxlength="16" class="form-control" name="nik" id="nikInput" placeholder="NIK" required>
                    </div>

                    <div class="mb-3">
                        <label for="namaInput" class"form-label">Nama</label>
                        <input type="text" class="form-control" name="nama" id="namaInput" placeholder="Nama" required>
                    </div>

                    <div class="mb-3">
                        <label for="telpInput" class"form-label">Nomor Telepon</label>
                        <input type="tel" pattern="[0-9]{11}" class="form-control" name="notelp" id="telpInput" placeholder="Nomor Telepon" required>
                        <div id="telHelp" class="form-text">Contoh: 02123456789</div>
                    </div>

                    <div class="mb-3">
                        <label for="hpInput" class"form-label">Nomor HP</label>
                        <input type="tel" pattern=".{11,13}" maxlength="13" class="form-control" name="nohp" id="hpInput" placeholder="Nomor HP" required>
                        <div id="hpHelp" class="form-text">Contoh: 081234567890</div>
                    </div>
                    
                    <br>
                    <h5>Alamat sesuai KTP</h5>

                    <div class="mb-3">
                        <label for="jalanKtpInput" class"form-label">Jalan</label>
                        <input type="text" class="form-control" name="ktp_jalan" id="jalanKtpInput" placeholder="Jalan" required>
                    </div>

                    <div class="mb-3">
                        <label for="kelKtpInput" class"form-label">Kelurahan</label>
                        <input type="text" class="form-control" name="ktp_kelurahan" id="kelKtpInput" placeholder="Kelurahan" required>
                    </div>

                    <div class="mb-3">
                        <label for="kecKtpInput" class"form-label">Kecamatan</label>
                        <input type="text" class="form-control" name="ktp_kecamatan" id="kecKtpInput" placeholder="Kecamatan" required>
                    </div>

                    <div class="mb-3">
                        <label for="kabkotKtpInput" class"form-label">Kabupaten/Kota</label>
                        <input type="text" class="form-control" name="ktp_kabkot" id="kabkotKtpInput" placeholder="Kabupaten/Kota" required>
                    </div>

                    <div class="mb-3">
                        <label for="provKtpInput" class"form-label">Provinsi</label>
                        <input type="text" class="form-control" name="ktp_prov" id="provKtpInput" placeholder="Provinsi" required>
                    </div>

                    <br>
                    <h5>Alamat Domisili</h5>

                    <div class="mb-3">
                        <label for="jalanDomInput" class"form-label">Jalan</label>
                        <input type="text" class="form-control" name="dom_jalan" id="jalanDomInput" placeholder="Jalan" required>
                    </div>

                    <div class="mb-3">
                        <label for="kelDomInput" class"form-label">Kelurahan</label>
                        <input type="text" class="form-control" name="dom_kelurahan" id="kelDomInput" placeholder="Kelurahan" required>
                    </div>

                    <div class="mb-3">
                        <label for="kecDomInput" class"form-label">Kecamatan</label>
                        <input type="text" class="form-control" name="dom_kecamatan" id="kecDomInput" placeholder="Kecamatan" required>
                    </div>

                    <div class="mb-3">
                        <label for="kabkotDomInput" class"form-label">Kabupaten/Kota</label>
                        <input type="text" class="form-control" name="dom_kabkot" id="kabkotDomInput" placeholder="Kabupaten/Kota" required>
                    </div>

                    <div class="mb-3">
                        <label for="provDomInput" class"form-label">Provinsi</label>
                        <input type="text" class="form-control" name="dom_prov" id="provDomInput" placeholder="Provinsi" required>
                    </div>

                    <figure class="text-center">
                        {% for message in messages %}
                        {{ message }}
                        <br>
                        {% endfor %}

                        <button type="submit" class="btn btn-outline-success" onclick="check_data()">Simpan</button>
                    </figure>
                </form>
            </div>
        <div class="col"></div>
    </div>
</div>
{% else %}
<figure class="text-center">
    <h1>Anda tidak punya akses untuk halaman ini</h1>
</figure>
{% endif %}
<script src="{% static 'daftar_pasien/script.js' %}"></script>
{% endblock content %}

daftar_pasien/templates/daftar_pasien/list_pasien.html
{% extends 'base.html' %}

{% block content %}
{% if request.session.peran == 'pengguna publik' %}
<div class="container">
    <div class="table-responsive">
        <table class="table">
            <thead>
                <tr>
                    <th scope="col">No</th>
                    <th scope="col">NIK</th>
                    <th>Nama Pasien</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
            {% for detail in pasien %}
            <tr>
                <td>{{ forloop.counter }}</td>
                <td>{{ detail.0 }}</td>
                <td>{{ detail.2 }}</td>
                <td>
                    <a href="{% url 'daftar_pasien:update_pasien' nik=detail.0 %}" class="btn btn-outline-success">Update</a>
                    <a href="{% url 'daftar_pasien:delete_pasien' nik=detail.0 %}" class="btn btn-outline-danger">Delete</a>
                    <a href="{% url 'daftar_pasien:detail_pasien' nik=detail.0 %}" class="btn btn-outline-primary">Detail</a>
                </td>
            </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>
</div>
{% else %}
<figure class="text-center">
    <h1>Anda tidak punya akses untuk halaman ini</h1>
</figure>
{% endif %}
{% endblock content %}

daftar_pasien/templates/daftar_pasien/update.html
{% extends 'base.html' %}
{% load static %}

{% block content %}
{% if request.session.peran == 'pengguna publik' %}
<div class="container">
    <div class="row"></div>
    <div class="row align-items-center">
        <div class="col"></div>
        <div class="col-6">
            {% for detail in pasien %}
            <form method="POST" class="was-validated" action="{% url 'daftar_pasien:update_pasien' nik=detail.0 %}">
                {% csrf_token %}
                <figure class="text-center">
                    <h3>Siruco - Daftar Pasien</h3>
                </figure>

                <div class="mb-3">
                    <label for="usernameInput" class="form-label">Pendaftar</label>
                    <input type="text" class="form-control disabled" name="idpendaftar" id="usernameInput" value="{{ request.session.username }}" disabled readonly>
                </div>

                <div class="mb-3 has-validation">
                    <label for="nikInput" class"form-label">NIK</label>
                    <input type="tel" pattern="[0-9]{16}" maxlength="16" class="form-control" name="nik" id="nikInput" value="{{ detail.0 }}" disabled readonly>
                </div>

                <div class="mb-3">
                    <label for="namaInput" class"form-label">Nama</label>
                    <input type="text" class="form-control" name="nama" id="namaInput" value="{{ detail.2 }}" disabled readonly>
                </div>

                <div class="mb-3">
                    <label for="telpInput" class"form-label">Nomor Telepon</label>
                    <input type="tel" pattern="[0-9]{11}" class="form-control" name="notelp" id="telpInput" placeholder="Nomor Telepon" value="{{ detail.13 }}" required>
                    <div id="telHelp" class="form-text">Contoh: 02123456789</div>
                </div>

                <div class="mb-3">
                    <label for="hpInput" class"form-label">Nomor HP</label>
                    <input type="tel" pattern=".{11,13}" maxlength="13" class="form-control" name="nohp" id="hpInput" placeholder="Nomor HP" value="{{ detail.14 }}" required>
                    <div id="hpHelp" class="form-text">Contoh: 081234567890</div>
                </div>
                
                <br>
                <h5>Alamat sesuai KTP</h5>

                <div class="mb-3">
                    <label for="jalanKtpInput" class"form-label">Jalan</label>
                    <input type="text" class="form-control" name="ktp_jalan" id="jalanKtpInput" placeholder="Jalan" value="{{ detail.3 }}" required>
                </div>

                <div class="mb-3">
                    <label for="kelKtpInput" class"form-label">Kelurahan</label>
                    <input type="text" class="form-control" name="ktp_kelurahan" id="kelKtpInput" placeholder="Kelurahan" value="{{ detail.4 }}" required>
                </div>

                <div class="mb-3">
                    <label for="kecKtpInput" class"form-label">Kecamatan</label>
                    <input type="text" class="form-control" name="ktp_kecamatan" id="kecKtpInput" placeholder="Kecamatan" value="{{ detail.5 }}" required>
                </div>

                <div class="mb-3">
                    <label for="kabkotKtpInput" class"form-label">Kabupaten/Kota</label>
                    <input type="text" class="form-control" name="ktp_kabkot" id="kabkotKtpInput" placeholder="Kabupaten/Kota" value="{{ detail.6 }}" required>
                </div>

                <div class="mb-3">
                    <label for="provKtpInput" class"form-label">Provinsi</label>
                    <input type="text" class="form-control" name="ktp_prov" id="provKtpInput" placeholder="Provinsi" value="{{ detail.7 }}" required>
                </div>

                <br>
                <h5>Alamat Domisili</h5>

                <div class="mb-3">
                    <label for="jalanDomInput" class"form-label">Jalan</label>
                    <input type="text" class="form-control" name="dom_jalan" id="jalanDomInput" placeholder="Jalan" value="{{ detail.8 }}" required>
                </div>

                <div class="mb-3">
                    <label for="kelDomInput" class"form-label">Kelurahan</label>
                    <input type="text" class="form-control" name="dom_kelurahan" id="kelDomInput"placeholder="Kelurahan" value="{{ detail.9 }}" required>
                </div>

                <div class="mb-3">
                    <label for="kecDomInput" class"form-label">Kecamatan</label>
                    <input type="text" class="form-control" name="dom_kecamatan" id="kecDomInput" placeholder="Kecamatan" value="{{ detail.10 }}" required>
                </div>

                <div class="mb-3">
                    <label for="kabkotDomInput" class"form-label">Kabupaten/Kota</label>
                    <input type="text" class="form-control" name="dom_kabkot" id="kabkotDomInput" placeholder="Kabupaten/Kota" value="{{ detail.11 }}" required>
                </div>

                <div class="mb-3">
                    <label for="provDomInput" class"form-label">Provinsi</label>
                    <input type="text" class="form-control" name="dom_prov" id="provDomInput" placeholder="Provinsi" value="{{ detail.12 }}" required>
                </div>
                {% endfor %}

                <figure class="text-center">
                    {% for message in messages %}
                    {{ message }}
                    <br>
                    {% endfor %}

                    <button type="submit" class="btn btn-outline-success" onclick="check_data()">Simpan</button>
                </figure>
            </form>
        </div>
        <div class="col"></div>
    </div>
</div>
{% else %}
<figure class="text-center">
    <h1>Anda tidak punya akses untuk halaman ini</h1>
</figure>
{% endif %}
<script src="{% static 'daftar_pasien/script.js' %}"></script>
{% endblock content %}